--@description Mouse Modifier; Set Default
--@version 1.0
--@author MaxMusicMax
-- https://forum.cockos.com/showthread.php?p=2059855
-- #######################################
-- #######################################
function print_rs (param)
	reaper.ShowConsoleMsg (tostring (param) .. "\n");
end
-- #######################################
-- #######################################
function printTable(tbl, indent)
    indent = indent or 0  -- Устанавливаем отступ по умолчанию в 0, если он не задан
    local prefix = string.rep("  ", indent)  -- Создаем строку отступа на основе текущего уровня отступа

    for k, v in pairs(tbl) do  -- Проходим по всем парам ключ-значение в таблице
        if type(v) == "table" then  -- Если значение является таблицей
            reaper.ShowConsoleMsg(prefix .. tostring(k) .. ": {\n")  -- Печатаем ключ и открывающую скобку для новой таблицы
            printTable(v, indent + 1)  -- Рекурсивно вызываем printTable для вложенной таблицы, увеличивая уровень отступа
            reaper.ShowConsoleMsg(prefix .. "}\n")  -- Печатаем закрывающую скобку для таблицы
        else  -- Если значение не является таблицей
            reaper.ShowConsoleMsg(prefix .. tostring(k) .. ": " .. tostring(v) .. "\n")  -- Печатаем ключ и значение
        end
    end
end
-- #######################################
-- #######################################
function printValue(value, indent)
    indent = indent or 0  -- Устанавливаем отступ по умолчанию в 0, если он не задан
    local prefix = string.rep("  ", indent)  -- Создаем строку отступа на основе текущего уровня отступа

    if type(value) == "table" then  -- Если значение является таблицей
        reaper.ShowConsoleMsg(prefix .. "{\n")  -- Печатаем открывающую скобку для таблицы
        for k, v in pairs(value) do  -- Проходим по всем парам ключ-значение в таблице
            reaper.ShowConsoleMsg(prefix .. "  " .. tostring(k) .. ": ")  -- Печатаем ключ с отступом
            printValue(v, indent + 1)  -- Рекурсивно вызываем printValue для значения, увеличивая уровень отступа
        end
        reaper.ShowConsoleMsg(prefix .. "}\n")  -- Печатаем закрывающую скобку для таблицы
    else  -- Если значение не является таблицей
        reaper.ShowConsoleMsg(prefix .. tostring(value) .. "\n")  -- Печатаем значение
    end
end
-- #######################################
-- #######################################
reaper.PreventUIRefresh(1);
-- #######################################
-- #######################################
-- print_rs (track)

--[[

]]--
-- reaper.Main_OnCommand(40726, 0) -- Envelope: Insert 4 envelope points at time selection 40726
-- commandID = reaper.NamedCommandLookup("_RSd0e03fb8cf39d47509ddbf616a11d2b7e4afa29c")
-- reaper.Main_OnCommand(commandID, 0)
-- reaper.Main_OnCommand(reaper.NamedCommandLookup(39214), 0)
-- reaper.Main_OnCommand(reaper.NamedCommandLookup("_RSd0e03fb8cf39d47509ddbf616a11d2b7e4afa29c"), 0)


-- Set default mouse modifier action for
reaper.Main_OnCommand(reaper.NamedCommandLookup("39770"), 0) -- "Arrange view middle drag" to "Hand scroll"
reaper.Main_OnCommand(reaper.NamedCommandLookup("39270"), 0) -- "Arrange view right drag" to "Marquee zoom"
reaper.Main_OnCommand(reaper.NamedCommandLookup("39001"), 0) -- "Media item left drag" to "Move item"
reaper.Main_OnCommand(reaper.NamedCommandLookup("39033"), 0) -- "Media item bottom half left drag" to "Move item"
reaper.Main_OnCommand(reaper.NamedCommandLookup("39513"), 0) -- "Media item left click" to "Select item and move edit cursor" (factory default)
reaper.Main_OnCommand(reaper.NamedCommandLookup("39545"), 0) -- "Media item bottom half left click" to "Select item and move edit cursor"
reaper.Main_OnCommand(reaper.NamedCommandLookup("25257"), 0) -- "Project marker/region edge left drag" to "Move project marker/region edge" (factory default)
reaper.Main_OnCommand(reaper.NamedCommandLookup("25001"), 0) -- "Project marker/region lane left drag" to "Hand scroll" (factory default)
reaper.Main_OnCommand(reaper.NamedCommandLookup("39609"), 0) -- "Ruler left click" to "Move edit cursor" (factory default)
reaper.Main_OnCommand(reaper.NamedCommandLookup("39233"), 0) -- "Ruler left drag" to "Hand scroll"
reaper.Main_OnCommand(reaper.NamedCommandLookup("39205"), 0) -- "Track left drag" to "Marquee add to item selection"
reaper.Main_OnCommand(reaper.NamedCommandLookup("39577"), 0) -- "Track left click" to "Deselect all items and move edit cursor" (factory default)
reaper.Main_OnCommand(reaper.NamedCommandLookup("25128"), 0) -- "Automation item left drag" to "No action"
reaper.Main_OnCommand(reaper.NamedCommandLookup("39801"), 0) -- "Edit cursor handle left drag" to "Scrub audio"

reaper.Main_OnCommand(reaper.NamedCommandLookup("39487"), 0) -- "MIDI piano roll left drag" to "Marquee select notes"
reaper.Main_OnCommand(reaper.NamedCommandLookup("39417"), 0) -- "MIDI ruler left drag" to "Edit loop point (ruler) or time selection (piano roll)" (factory default)
reaper.Main_OnCommand(reaper.NamedCommandLookup("39408"), 0) -- "MIDI CC event left click/drag" to "Edit CC events"
reaper.Main_OnCommand(reaper.NamedCommandLookup("39361"), 0) -- "MIDI CC lane left click/drag" to "Marquee select CC"
-- reaper.Main_OnCommand(reaper.NamedCommandLookup("www"), 0) -- www


-- reaper.Main_OnCommand(reaper.NamedCommandLookup("39579"), 0) -- "Track left click" to "Deselect all items"
-- #######################################
-- #######################################
reaper.PreventUIRefresh(-1);
reaper.TrackList_AdjustWindows(0)  -- Updates the window view
reaper.UpdateArrange();  -- Updates the window view
-- #######################################
-- #######################################
--[[
APIExists
APITest
AddMediaItemToTrack
AddProjectMarker
AddProjectMarker2
AddRemoveReaScript
AddTakeToMediaItem
AddTempoTimeSigMarker
AnyTrackSolo
ApplyNudge
ArmCommand
AudioAccessorStateChanged
AudioAccessorUpdate
AudioAccessorValidateState
Audio_Init
Audio_IsPreBuffer
Audio_IsRunning
Audio_Quit
BR_EnvAlloc
BR_EnvCountPoints
BR_EnvDeletePoint
BR_EnvFind
BR_EnvFindNext
BR_EnvFindPrevious
BR_EnvFree
BR_EnvGetParentTake
BR_EnvGetParentTrack
BR_EnvGetPoint
BR_EnvGetProperties
BR_EnvSetPoint
BR_EnvSetProperties
BR_EnvValueAtPos
BR_GetMediaSourceProperties
BR_GetMouseCursorContext
BR_GetMouseCursorContext_Envelope
BR_GetMouseCursorContext_Item
BR_GetMouseCursorContext_MIDI
BR_GetMouseCursorContext_Position
BR_GetMouseCursorContext_StretchMarker
BR_GetMouseCursorContext_Take
BR_GetMouseCursorContext_Track
BR_ItemAtMouseCursor
BR_MIDI_CCLaneRemove
BR_MIDI_CCLaneReplace
BR_PositionAtMouseCursor
BR_SetMediaSourceProperties
BR_SetTakeSourceFromFile
BR_SetTakeSourceFromFile2
BR_TakeAtMouseCursor
BR_TrackAtMouseCursor
BypassFxAllTracks
CSurf_FlushUndo
CSurf_GetTouchState
CSurf_GoEnd
CSurf_GoStart
CSurf_NumTracks
CSurf_OnArrow
CSurf_OnFXChange
CSurf_OnFwd
CSurf_OnInputMonitorChange
CSurf_OnInputMonitorChangeEx
CSurf_OnMuteChange
CSurf_OnMuteChangeEx
CSurf_OnPanChange
CSurf_OnPanChangeEx
CSurf_OnPause
CSurf_OnPlay
CSurf_OnPlayRateChange
CSurf_OnRecArmChange
CSurf_OnRecArmChangeEx
CSurf_OnRecord
CSurf_OnRecvPanChange
CSurf_OnRecvVolumeChange
CSurf_OnRew
CSurf_OnRewFwd
CSurf_OnScroll
CSurf_OnSelectedChange
CSurf_OnSendPanChange
CSurf_OnSendVolumeChange
CSurf_OnSoloChange
CSurf_OnSoloChangeEx
CSurf_OnStop
CSurf_OnTempoChange
CSurf_OnTrackSelection
CSurf_OnVolumeChange
CSurf_OnVolumeChangeEx
CSurf_OnWidthChange
CSurf_OnWidthChangeEx
CSurf_OnZoom
CSurf_ResetAllCachedVolPanStates
CSurf_ScrubAmt
CSurf_SetAutoMode
CSurf_SetPlayState
CSurf_SetRepeatState
CSurf_SetSurfaceMute
CSurf_SetSurfacePan
CSurf_SetSurfaceRecArm
CSurf_SetSurfaceSelected
CSurf_SetSurfaceSolo
CSurf_SetSurfaceVolume
CSurf_SetTrackListChange
CSurf_TrackFromID
CSurf_TrackToID
CalculateNormalization
ClearAllRecArmed
ClearConsole
ClearPeakCache
ColorFromNative
ColorToNative
CountAutomationItems
CountEnvelopePoints
CountEnvelopePointsEx
CountMediaItems
CountProjectMarkers
CountSelectedMediaItems
CountSelectedTracks
CountSelectedTracks2
CountTCPFXParms
CountTakeEnvelopes
CountTakes
CountTempoTimeSigMarkers
CountTrackEnvelopes
CountTrackMediaItems
CountTracks
CreateNewMIDIItemInProj
CreateTakeAudioAccessor
CreateTrackAudioAccessor
CreateTrackSend
DB2SLIDER
DeleteEnvelopePointEx
DeleteEnvelopePointRange
DeleteEnvelopePointRangeEx
DeleteExtState
DeleteProjectMarker
DeleteProjectMarkerByIndex
DeleteTakeMarker
DeleteTakeStretchMarkers
DeleteTempoTimeSigMarker
DeleteTrack
DeleteTrackMediaItem
DestroyAudioAccessor
DockGetPosition
DockIsChildOfDock
DockWindowActivate
DockWindowAdd
DockWindowAddEx
DockWindowRefresh
DockWindowRefreshForHWND
DockWindowRemove
Dock_UpdateDockID
EditTempoTimeSigMarker
EnsureNotCompletelyOffscreen
EnumPitchShiftModes
EnumPitchShiftSubModes
EnumProjExtState
EnumProjectMarkers
EnumProjectMarkers2
EnumProjectMarkers3
EnumProjects
EnumRegionRenderMatrix
EnumTrackMIDIProgramNames
EnumTrackMIDIProgramNamesEx
EnumerateFiles
EnumerateSubdirectories
Envelope_Evaluate
Envelope_FormatValue
Envelope_GetParentTake
Envelope_GetParentTrack
Envelope_SortPoints
Envelope_SortPointsEx
ExecProcess
FNG_AddMidiNote
FNG_AllocMidiTake
FNG_CountMidiNotes
FNG_FreeMidiTake
FNG_GetMidiNote
FNG_GetMidiNoteIntProperty
FNG_SetMidiNoteIntProperty
FindTempoTimeSigMarker
GR_SelectColor
GSC_mainwnd
GetActiveTake
GetAllProjectPlayStates
GetAppVersion
GetArmedCommand
GetAudioAccessorEndTime
GetAudioAccessorHash
GetAudioAccessorSamples
GetAudioAccessorStartTime
GetAudioDeviceInfo
GetConfigWantsDock
GetCurrentProjectInLoadSave
GetCursorContext
GetCursorContext2
GetCursorPosition
GetCursorPositionEx
GetDisplayedMediaItemColor
GetDisplayedMediaItemColor2
GetEnvelopeInfo_Value
GetEnvelopeName
GetEnvelopePoint
GetEnvelopePointByTime
GetEnvelopePointByTimeEx
GetEnvelopePointEx
GetEnvelopeScalingMode
GetEnvelopeStateChunk
GetExePath
GetExtState
GetFXEnvelope
GetFocusedFX
GetFocusedFX2
GetFreeDiskSpaceForRecordPath
GetGlobalAutomationOverride
GetHZoomLevel
GetInputChannelName
GetInputOutputLatency
GetItemEditingTime2
GetItemFromPoint
GetItemProjectContext
GetItemStateChunk
GetLastColorThemeFile
GetLastMarkerAndCurRegion
GetLastTouchedFX
GetLastTouchedTrack
GetMIDIInputName
GetMIDIOutputName
GetMainHwnd
GetMasterMuteSoloFlags
GetMasterTrack
GetMasterTrackVisibility
GetMaxMidiInputs
GetMaxMidiOutputs
GetMediaFileMetadata
GetMediaItem
GetMediaItemInfo_Value
GetMediaItemNumTakes
GetMediaItemTake
GetMediaItemTakeByGUID
GetMediaItemTakeInfo_Value
GetMediaItemTake_Item
GetMediaItemTake_Peaks
GetMediaItemTake_Source
GetMediaItemTake_Track
GetMediaItemTrack
GetMediaItem_Track
GetMediaSourceFileName
GetMediaSourceLength
GetMediaSourceNumChannels
GetMediaSourceParent
GetMediaSourceSampleRate
GetMediaSourceType
GetMediaTrackInfo_Value
GetMixerScroll
GetMouseModifier
GetMousePosition
GetNumAudioInputs
GetNumAudioOutputs
GetNumMIDIInputs
GetNumMIDIOutputs
GetNumTakeMarkers
GetNumTracks
GetOS
GetOutputChannelName
GetOutputLatency
GetParentTrack
GetPeakFileName
GetPeakFileNameEx
GetPeakFileNameEx2
GetPlayPosition
GetPlayPosition2
GetPlayPosition2Ex
GetPlayPositionEx
GetPlayState
GetPlayStateEx
GetProjExtState
GetProjectLength
GetProjectName
GetProjectPath
GetProjectPathEx
GetProjectStateChangeCount
GetProjectTimeOffset
GetProjectTimeSignature
GetProjectTimeSignature2
GetResourcePath
GetSelectedEnvelope
GetSelectedMediaItem
GetSelectedTrack
GetSelectedTrack2
GetSelectedTrackEnvelope
GetSetAutomationItemInfo
GetSetAutomationItemInfo_String
GetSetEnvelopeInfo_String
GetSetEnvelopeState
GetSetEnvelopeState2
GetSetItemState
GetSetItemState2
GetSetMediaItemInfo_String
GetSetMediaItemTakeInfo_String
GetSetMediaTrackInfo_String
GetSetProjectAuthor
GetSetProjectGrid
GetSetProjectInfo
GetSetProjectInfo_String
GetSetProjectNotes
GetSetRepeat
GetSetRepeatEx
GetSetTrackGroupMembership
GetSetTrackGroupMembershipHigh
GetSetTrackSendInfo_String
GetSetTrackState
GetSetTrackState2
GetSet_ArrangeView2
GetSet_LoopTimeRange
GetSet_LoopTimeRange2
GetSubProjectFromSource
GetTCPFXParm
GetTake
GetTakeEnvelope
GetTakeEnvelopeByName
GetTakeMarker
GetTakeName
GetTakeNumStretchMarkers
GetTakeStretchMarker
GetTakeStretchMarkerSlope
GetTempoMatchPlayRate
GetTempoTimeSigMarker
GetThemeColor
GetThingFromPoint
GetToggleCommandState
GetToggleCommandState3
GetToggleCommandStateEx
GetTooltipWindow
GetTrack
GetTrackAutomationMode
GetTrackColor
GetTrackDepth
GetTrackEnvelope
GetTrackEnvelopeByChunkName
GetTrackEnvelopeByName
GetTrackFromPoint
GetTrackGUID
GetTrackMIDILyrics
GetTrackMIDINoteName
GetTrackMIDINoteNameEx
GetTrackMIDINoteRange
GetTrackMediaItem
GetTrackName
GetTrackNumMediaItems
GetTrackNumSends
GetTrackReceiveName
GetTrackReceiveUIMute
GetTrackReceiveUIVolPan
GetTrackSendInfo_Value
GetTrackSendName
GetTrackSendUIMute
GetTrackSendUIVolPan
GetTrackState
GetTrackStateChunk
GetTrackUIMute
GetTrackUIPan
GetTrackUIVolPan
GetUnderrunTime
GetUserFileNameForRead
GetUserInputs
GetVolumeEnvelopeScaling
GoToMarker
GoToRegion
HasExtState
HasTrackMIDIPrograms
HasTrackMIDIProgramsEx
Help_Set
HiresPeaksFromSource
InsertAutomationItem
InsertEnvelopePoint
InsertEnvelopePointEx
InsertMedia
InsertMediaSection
InsertTrackAtIndex
IsMediaExtension
IsMediaItemSelected
IsProjectDirty
IsTrackSelected
IsTrackVisible
LICE_ClipLine
LocalizeString
Loop_OnArrow
MB
MIDIEditor_EnumTakes
MIDIEditor_GetActive
MIDIEditor_GetMode
MIDIEditor_GetSetting_int
MIDIEditor_GetSetting_str
MIDIEditor_GetTake
MIDIEditor_LastFocused_OnCommand
MIDIEditor_OnCommand
MIDIEditor_SetSetting_int
MIDI_CountEvts
MIDI_DeleteCC
MIDI_DeleteEvt
MIDI_DeleteNote
MIDI_DeleteTextSysexEvt
MIDI_DisableSort
MIDI_EnumSelCC
MIDI_EnumSelEvts
MIDI_EnumSelNotes
MIDI_EnumSelTextSysexEvts
MIDI_GetAllEvts
MIDI_GetCC
MIDI_GetCCShape
MIDI_GetEvt
MIDI_GetGrid
MIDI_GetHash
MIDI_GetNote
MIDI_GetPPQPosFromProjQN
MIDI_GetPPQPosFromProjTime
MIDI_GetPPQPos_EndOfMeasure
MIDI_GetPPQPos_StartOfMeasure
MIDI_GetProjQNFromPPQPos
MIDI_GetProjTimeFromPPQPos
MIDI_GetRecentInputEvent
MIDI_GetScale
MIDI_GetTextSysexEvt
MIDI_GetTrackHash
MIDI_InsertCC
MIDI_InsertEvt
MIDI_InsertNote
MIDI_InsertTextSysexEvt
MIDI_SelectAll
MIDI_SetAllEvts
MIDI_SetCC
MIDI_SetCCShape
MIDI_SetEvt
MIDI_SetItemExtents
MIDI_SetNote
MIDI_SetTextSysexEvt
MIDI_Sort
Main_OnCommand
Main_OnCommandEx
Main_SaveProject
Main_UpdateLoopInfo
Main_openProject
MarkProjectDirty
MarkTrackItemsDirty
Master_GetPlayRate
Master_GetPlayRateAtTime
Master_GetTempo
Master_NormalizePlayRate
Master_NormalizeTempo
MediaItemDescendsFromTrack
MoveEditCursor
MoveMediaItemToTrack
MuteAllTracks
NamedCommandLookup
OnPauseButton
OnPauseButtonEx
OnPlayButton
OnPlayButtonEx
OnStopButton
OnStopButtonEx
OpenColorThemeFile
OpenMediaExplorer
OscLocalMessageToHost
PCM_Sink_Enum
PCM_Sink_GetExtension
PCM_Sink_ShowConfig
PCM_Source_BuildPeaks
PCM_Source_CreateFromFile
PCM_Source_CreateFromFileEx
PCM_Source_CreateFromType
PCM_Source_Destroy
PCM_Source_GetPeaks
PCM_Source_GetSectionInfo
PluginWantsAlwaysRunFx
PreventUIRefresh
PromptForAction
ReaScriptError
RecursiveCreateDirectory
RefreshToolbar
RefreshToolbar2
RemoveTrackSend
RenderFileSection
ReorderSelectedTracks
Resample_EnumModes
ReverseNamedCommandLookup
SLIDER2DB
SNM_AddReceive
SNM_AddTCPFXParm
SNM_CreateFastString
SNM_DeleteFastString
SNM_GetDoubleConfigVar
SNM_GetFastString
SNM_GetFastStringLength
SNM_GetIntConfigVar
SNM_GetMIDIEditorActiveTake
SNM_GetMediaItemTakeByGUID
SNM_GetProjectMarkerName
SNM_GetSetObjectState
SNM_GetSetSourceState
SNM_GetSetSourceState2
SNM_GetSourceType
SNM_MoveOrRemoveTrackFX
SNM_RemoveReceive
SNM_RemoveReceivesFrom
SNM_SelectResourceBookmark
SNM_SetDoubleConfigVar
SNM_SetFastString
SNM_SetIntConfigVar
SNM_SetProjectMarker
SNM_TieResourceSlotActions
ScaleFromEnvelopeMode
ScaleToEnvelopeMode
SelectAllMediaItems
SelectProjectInstance
SetActiveTake
SetAutomationMode
SetCurrentBPM
SetCursorContext
SetEditCurPos
SetEditCurPos2
SetEnvelopePoint
SetEnvelopePointEx
SetEnvelopeStateChunk
SetExtState
SetGlobalAutomationOverride
SetItemStateChunk
SetMIDIEditorGrid
SetMasterTrackVisibility
SetMediaItemInfo_Value
SetMediaItemLength
SetMediaItemPosition
SetMediaItemSelected
SetMediaItemTakeInfo_Value
SetMediaItemTake_Source
SetMediaTrackInfo_Value
SetMixerScroll
SetMouseModifier
SetOnlyTrackSelected
SetProjExtState
SetProjectGrid
SetProjectMarker
SetProjectMarker2
SetProjectMarker3
SetProjectMarker4
SetProjectMarkerByIndex
SetProjectMarkerByIndex2
SetRegionRenderMatrix
SetTakeMarker
SetTakeStretchMarker
SetTakeStretchMarkerSlope
SetTempoTimeSigMarker
SetThemeColor
SetToggleCommandState
SetTrackAutomationMode
SetTrackColor
SetTrackMIDILyrics
SetTrackMIDINoteName
SetTrackMIDINoteNameEx
SetTrackSelected
SetTrackSendInfo_Value
SetTrackSendUIPan
SetTrackSendUIVol
SetTrackStateChunk
ShowActionList
ShowConsoleMsg
ShowMessageBox
ShowPopupMenu
SnapToGrid
SoloAllTracks
Splash_GetWnd
SplitMediaItem
StuffMIDIMessage
TakeFX_AddByName
TakeFX_CopyToTake
TakeFX_CopyToTrack
TakeFX_Delete
TakeFX_EndParamEdit
TakeFX_FormatParamValue
TakeFX_FormatParamValueNormalized
TakeFX_GetChainVisible
TakeFX_GetCount
TakeFX_GetEnabled
TakeFX_GetEnvelope
TakeFX_GetFXGUID
TakeFX_GetFXName
TakeFX_GetFloatingWindow
TakeFX_GetFormattedParamValue
TakeFX_GetIOSize
TakeFX_GetNamedConfigParm
TakeFX_GetNumParams
TakeFX_GetOffline
TakeFX_GetOpen
TakeFX_GetParam
TakeFX_GetParamEx
TakeFX_GetParamFromIdent
TakeFX_GetParamIdent
TakeFX_GetParamName
TakeFX_GetParamNormalized
TakeFX_GetParameterStepSizes
TakeFX_GetPinMappings
TakeFX_GetPreset
TakeFX_GetPresetIndex
TakeFX_GetUserPresetFilename
TakeFX_NavigatePresets
TakeFX_SetEnabled
TakeFX_SetNamedConfigParm
TakeFX_SetOffline
TakeFX_SetOpen
TakeFX_SetParam
TakeFX_SetParamNormalized
TakeFX_SetPinMappings
TakeFX_SetPreset
TakeFX_SetPresetByIndex
TakeFX_Show
TakeIsMIDI
ThemeLayout_GetLayout
ThemeLayout_GetParameter
ThemeLayout_RefreshAll
ThemeLayout_SetLayout
ThemeLayout_SetParameter
TimeMap2_GetDividedBpmAtTime
TimeMap2_GetNextChangeTime
TimeMap2_QNToTime
TimeMap2_beatsToTime
TimeMap2_timeToBeats
TimeMap2_timeToQN
TimeMap_GetDividedBpmAtTime
TimeMap_GetMeasureInfo
TimeMap_GetMetronomePattern
TimeMap_GetTimeSigAtTime
TimeMap_QNToMeasures
TimeMap_QNToTime
TimeMap_QNToTime_abs
TimeMap_curFrameRate
TimeMap_timeToQN
TimeMap_timeToQN_abs
ToggleTrackSendUIMute
TrackCtl_SetToolTip
TrackFX_AddByName
TrackFX_CopyToTake
TrackFX_CopyToTrack
TrackFX_Delete
TrackFX_EndParamEdit
TrackFX_FormatParamValue
TrackFX_FormatParamValueNormalized
TrackFX_GetByName
TrackFX_GetChainVisible
TrackFX_GetCount
TrackFX_GetEQ
TrackFX_GetEQBandEnabled
TrackFX_GetEQParam
TrackFX_GetEnabled
TrackFX_GetFXGUID
TrackFX_GetFXName
TrackFX_GetFloatingWindow
TrackFX_GetFormattedParamValue
TrackFX_GetIOSize
TrackFX_GetInstrument
TrackFX_GetNamedConfigParm
TrackFX_GetNumParams
TrackFX_GetOffline
TrackFX_GetOpen
TrackFX_GetParam
TrackFX_GetParamEx
TrackFX_GetParamFromIdent
TrackFX_GetParamIdent
TrackFX_GetParamName
TrackFX_GetParamNormalized
TrackFX_GetParameterStepSizes
TrackFX_GetPinMappings
TrackFX_GetPreset
TrackFX_GetPresetIndex
TrackFX_GetRecChainVisible
TrackFX_GetRecCount
TrackFX_GetUserPresetFilename
TrackFX_NavigatePresets
TrackFX_SetEQBandEnabled
TrackFX_SetEQParam
TrackFX_SetEnabled
TrackFX_SetNamedConfigParm
TrackFX_SetOffline
TrackFX_SetOpen
TrackFX_SetParam
TrackFX_SetParamNormalized
TrackFX_SetPinMappings
TrackFX_SetPreset
TrackFX_SetPresetByIndex
TrackFX_Show
TrackList_AdjustWindows
TrackList_UpdateAllExternalSurfaces
Track_GetPeakHoldDB
Track_GetPeakInfo
ULT_GetMediaItemNote
ULT_SetMediaItemNote
Undo_BeginBlock
Undo_BeginBlock2
Undo_CanRedo2
Undo_CanUndo2
Undo_DoRedo2
Undo_DoUndo2
Undo_EndBlock
Undo_EndBlock2
Undo_OnStateChange
Undo_OnStateChange2
Undo_OnStateChangeEx
Undo_OnStateChangeEx2
Undo_OnStateChange_Item
UpdateArrange
UpdateItemInProject
UpdateTimeline
ValidatePtr
ValidatePtr2
ViewPrefs
adjustZoom
file_exists
format_timestr
format_timestr_len
format_timestr_pos
genGuid
get_config_var_string
get_ini_file
guidToString
image_resolve_fn
joystick_create
joystick_destroy
joystick_enum
joystick_getaxis
joystick_getbuttonmask
joystick_getinfo
joystick_getpov
joystick_update
midi_init
midi_reinit
mkpanstr
mkvolpanstr
mkvolstr
my_getViewport
parse_timestr
parse_timestr_len
parse_timestr_pos
parsepanstr
plugin_getFilterList
plugin_getImportableProjectFilterList
reduce_open_files
relative_fn
resolve_fn
resolve_fn2
stringToGuid
time_precise
]]--