--@description Popup Menu; Main; Insert Fx Or Complete The Command From The List Of Actions
--@version 1.0
--@author MaxMusicMax
-- https://forum.cockos.com/showthread.php?p=2059855
-- #######################################
-- #######################################
-- Настройки

-- Файл XML для редактирования меню пользователем. После редактирования меню (MenuPopupMain.xml) удалите файл "MenuPopupMain.TXT" чтобы он обновился
local xmlFileName = '/Scripts/MenuPopupMain.xml'

-- Любой путь к программе, двой слэш "\\" обязателен
local notepadPPPath = 'C:\\Program Files\\Notepad++\\notepad++.exe' -- https://notepad-plus-plus.org/downloads/

-- Файл TXT для более быстрой загрузки меню при вызове. Отредактируйте путь и имя файла как вам нужно.
local txtFileName = '/Scripts/MenuPopupMain.txt'

-- Настройки меню
local header_name = "Главное меню" -- Название заголовка меню
local show_window_header = false -- true/false -- Скрыть/показать заголовок меню (header_name)
local menu_header_position_x = -2 -- Положение меню от текущего положения курсора мыши
local menu_header_position_y = -2 -- Положение меню от текущего положения курсора мыши
local menu_header_width_x = 0 -- Ширина заголовка меню
local menu_header_width_y = 0 -- Высота заголовка меню

-- Настройка глобальных переменных для добавления FX
local show_fx = false -- Показывать/Не показывать плагин при добавлении -- true/false
local add_fx_to_item = true -- Добавлять FX к элементам -- true/false
local add_fx_to_track = true -- Добавлять FX к трекам -- true/false
local add_fx_to_master_track = true -- Добавлять FX к мастер треку -- true/false
-- Настройки
-- #####################################################
-- #####################################################
-- printTable
-- printValue
-- createDefaultXML
-- Add_FX
-- createMenuString
-- parseAttributes
-- parseXML
-- buildLuaTable
-- serializeTable
-- saveTableToFile
-- loadTableFromFile
-- openFileInNotepadPP
-- showMenu
-- #####################################################
-- #####################################################
reaper.PreventUIRefresh(1);
-- #####################################################
-- #####################################################
-- Функция для создания XML-файла по умолчанию
function createDefaultXML(xmlFilePath)
    local defaultXML = [[
<root>

<!--
Это примеры пунктов меню с разной функциональностью (не удаляйте их)
<Item itemName="Это пример пункта меню" typeMenu="subMenu">
	<Item itemName="Главное меню" typeMenu="item" action_id="disabled_item"></Item>
	<Item itemName="" typeMenu="separator"></Item>
	<Item itemName="Неактивный пункт меню" typeMenu="item" action_id="disabled_item"></Item>
	<Item itemName="ID команды (встроенная)" typeMenu="item" action_id="40934"></Item>
	<Item itemName="ID команды (пользовательская)" typeMenu="item" action_id="_RS251990727759d3dff9cf84df740cd6a87ea0d169"></Item>
	<Item itemName="ReaEQ (Cockos)" typeMenu="item" add_fx="Имя плагина — ReaEQ (Cockos)"></Item>
	<Item itemName="ReaEQ" typeMenu="item" add_fx="ReaEQ (Cockos)" preset_name="Имя пресета"></Item>
	<Item itemName="" typeMenu="separator"></Item>
	<Item itemName="Настройки" typeMenu="subMenu">
		<item itemName="Удалить файл кэша" typeMenu="item" action_id="delete_cache" />
		<item itemName="Окрыть XML" typeMenu="item" action_id="open_in_notepadpp" />
	</Item>
</Item>

не используйте в названиях символы «двойные кавычки» — " и символ & ` ~ #
-->

	<Item itemName="Главное меню" typeMenu="item" action_id="disabled_item"></Item>
	<Item itemName="" typeMenu="separator"></Item>
	
	<!-- Примеры -->
	<Item itemName="Примеры  ~`&&&& # $ ^ *" typeMenu="subMenu">
		<Item itemName="Неактивный пункт меню" typeMenu="item" action_id="disabled_item"></Item>
		<Item itemName="" typeMenu="separator"></Item>
		<Item itemName="Track: Insert new track (встроенная комманда)" typeMenu="item" action_id="40001"></Item>
		<Item itemName="Track: Set to random colors (встроенная комманда)" typeMenu="item" action_id="40358"></Item>
		<Item itemName="Archie_Gui; Color switch. (пользовательская комманда)" typeMenu="item" action_id="_RS1bba6d1e6fad1fee16900e38aa15db5a9bf58fae"></Item>
		<Item itemName="" typeMenu="separator"></Item>
		<Item itemName="ReaEQ (без пресета)" typeMenu="item" add_fx="ReaEQ (Cockos)" preset_name=""></Item>
		<Item itemName="ReaEQ (с пресетом) (только внутренние пресеты Reaper)" typeMenu="item" add_fx="ReaEQ (Cockos)" preset_name="stock - Basic 11 band Cymbals"></Item>
		<Item itemName="" typeMenu="separator"></Item>
		<Item itemName="Настройки" typeMenu="subMenu">
			<item itemName="Удалить файл кэша" typeMenu="item" action_id="delete_cache" />
			<item itemName="Окрыть XML" typeMenu="item" action_id="open_in_notepadpp" />
		</Item>
	</Item>
	<!-- Примеры -->
	
	<!-- FX Plugins -->
	<Item itemName="FX Plugins" typeMenu="subMenu">
		
		<!-- Control -->
		<Item itemName="Control" typeMenu="subMenu">
			<Item itemName="ReaControlMIDI" typeMenu="item" add_fx="ReaControlMIDI (Cockos)"></Item>
		</Item>
		<!-- Control -->
		
		<!-- Pitch -->
		<Item itemName="Pitch" typeMenu="subMenu">
			<Item itemName="ReaPitch" typeMenu="item" add_fx="ReaPitch (Cockos)" preset_name=""></Item>
		</Item>
		<!-- Pitch -->
		
		<!-- Cockos -->
		<Item itemName="Cockos" typeMenu="subMenu">
			<Item itemName="ReaPitch" typeMenu="item" add_fx="ReaPitch (Cockos)"></Item>
			<Item itemName="ReaEQ" typeMenu="item" add_fx="ReaEQ (Cockos)"></Item>
			<Item itemName="ReaDelay" typeMenu="item" add_fx="ReaDelay (Cockos)"></Item>
			<Item itemName="ReaComp" typeMenu="item" add_fx="ReaComp (Cockos)"></Item>
			<Item itemName="ReaLimit" typeMenu="item" add_fx="ReaLimit (Cockos)"></Item>
			<Item itemName="ReaControlMIDI" typeMenu="item" add_fx="ReaControlMIDI (Cockos)"></Item>
			<Item itemName="ReaGate" typeMenu="item" add_fx="ReaGate (Cockos)"></Item>
			<Item itemName="ReaSurround" typeMenu="item" add_fx="ReaSurround (Cockos)"></Item>
			<Item itemName="ReaSurroundPan" typeMenu="item" add_fx="ReaSurroundPan (Cockos)"></Item>
			<Item itemName="ReaTune" typeMenu="ReaTune" add_fx="ReaTune (Cockos)"></Item>
			<Item itemName="ReaVerb" typeMenu="item" add_fx="ReaVerb (Cockos)"></Item>
			<Item itemName="ReaVerbate" typeMenu="item" add_fx="ReaVerbate (Cockos)"></Item>
			<Item itemName="ReaVocode" typeMenu="item" add_fx="ReaVocode (Cockos)"></Item>
			<Item itemName="ReaVoice" typeMenu="item" add_fx="ReaVoice (Cockos)"></Item>
			<Item itemName="ReaXcomp" typeMenu="item" add_fx="ReaXcomp (Cockos)"></Item>
			<Item itemName="ReaSamplOmatic5000" typeMenu="item" add_fx="ReaSamplOmatic5000 (Cockos)"></Item>
			<Item itemName="ReaSynth" typeMenu="item" add_fx="ReaSynth (Cockos)"></Item>
		</Item>
		<!-- Cockos -->
	</Item>
	<!-- FX Plugins -->
	
	<!-- VST Instruments -->
	<Item itemName="VST Instruments" typeMenu="subMenu">
		<Item itemName="ReaSynth (Cockos)" typeMenu="item" add_fx="ReaSynth (Cockos)" preset_name=""></Item>
	</Item>
	<!-- VST Instruments -->
	
	<Item itemName="" typeMenu="separator"></Item>
	
	<!-- Color -->
	<Item itemName="Color" typeMenu="subMenu">
		<Item itemName="View: Show peaks display settings" typeMenu="item" action_id="42074"></Item>
		<Item itemName="Options: Show theme adjuster" typeMenu="item" action_id="42234"></Item>
		<Item itemName="Options: Show theme color controls" typeMenu="item" action_id="42392"></Item>
		<Item itemName="Theme development: Show theme tweak/configuration window" typeMenu="item" action_id="41930"></Item>
	</Item>
	<!-- Color -->
	
	<!-- Envelope -->
	<Item itemName="Envelope" typeMenu="subMenu">
		<item itemName="Envelope: Show all envelopes for track" typeMenu="item" action_id="41148" />
		<item itemName="Envelope: Hide all envelopes for track" typeMenu="item" action_id="40889" />
		<Item itemName="" typeMenu="separator"></Item>
		<item itemName="Envelope: Show all envelopes for all tracks" typeMenu="item" action_id="41149" />
		<item itemName="Envelope: Hide all envelopes for all tracks" typeMenu="item" action_id="41150" />
		<Item itemName="" typeMenu="separator"></Item>
		<item itemName="Envelope: Insert automation item" typeMenu="item" action_id="42082" />
		<item itemName="Envelope: Duplicate automation items" typeMenu="item" action_id="42083" />
		<item itemName="Envelope: Duplicate and pool automation items" typeMenu="item" action_id="42085" />
	</Item>
	<!-- Envelope -->
	
	<!-- Grid -->
	<Item itemName="Grid" typeMenu="subMenu">	
		<Item itemName="Grid: Set to 1" typeMenu="item" action_id="40781"></Item>
		<Item itemName="Grid: Set to 1/2" typeMenu="item" action_id="40780"></Item>
		<Item itemName="Grid: Set to 1 /3 (1 /2 triplet)" typeMenu="item" action_id="42000"></Item>
		<Item itemName="Grid: Set to 1/4" typeMenu="item" action_id="40779"></Item>
		<Item itemName="Grid: Set to 1 /5 (1 /4 quintuplet)" typeMenu="item" action_id="42005"></Item>
		<Item itemName="Grid: Set to 1 /6 (1 /4 triplet)" typeMenu="item" action_id="41214"></Item>
		<Item itemName="Grid: Set to 1 /7 (1 /4 septuplet)" typeMenu="item" action_id="42004"></Item>
		<Item itemName="Grid: Set to 1/8" typeMenu="item" action_id="40778"></Item>
		<Item itemName="Grid: Set to 1/9" typeMenu="item" action_id="42003"></Item>
		<Item itemName="Grid: Set to 1 /10 (1 /8 quintuplet)" typeMenu="item" action_id="42002"></Item>
		<Item itemName="Grid: Set to 1 /12 (1 /8 triplet)" typeMenu="item" action_id="40777"></Item>
		<Item itemName="Grid: Set to 1/16" typeMenu="item" action_id="40776"></Item>
		<Item itemName="Grid: Set to 1/18" typeMenu="item" action_id="42001"></Item>
		<Item itemName="Grid: Set to 1/24 (1/16 triplet)" typeMenu="item" action_id="41213"></Item>
		<Item itemName="Grid: Set to 1/32" typeMenu="item" action_id="40775"></Item>
		<Item itemName="Grid: Set to 1 /48 (1 /32 triplet)" typeMenu="item" action_id="41212"></Item>
		<Item itemName="Grid: Set to 1/64" typeMenu="item" action_id="40774"></Item>
		<Item itemName="Grid: Set to 1/128" typeMenu="item" action_id="41047"></Item>
		<Item itemName="Grid: Set to 2" typeMenu="item" action_id="41210"></Item>
		<Item itemName="Grid: Set to 2/3 (whole note triplet)" typeMenu="item" action_id="42007"></Item>
		<Item itemName="Grid: Set to 3" typeMenu="item" action_id="42006"></Item>
		<Item itemName="Grid: Set to 4" typeMenu="item" action_id="41211"></Item>
	</Item>
	<!-- Grid -->
	
	<!-- Items -->
	<Item itemName="Items" typeMenu="subMenu">
		<Item itemName="Item properties: Toggle take reverse" typeMenu="item" action_id="41051"></Item>
		<Item itemName="" typeMenu="separator"></Item>
		<Item itemName="Item grouping: Group items" typeMenu="item" action_id="40032"></Item>
		<Item itemName="Item grouping: Remove items from group" typeMenu="item" action_id="40033"></Item>
		<Item itemName="Item grouping: Select all items in groups" typeMenu="item" action_id="40034"></Item>
		<Item itemName="" typeMenu="separator"></Item>
		<Item itemName="Item grouping: Options: Toggle item grouping override" typeMenu="item" action_id="1156"></Item>
		<Item itemName="Options: Move envelope points with media items" typeMenu="item" action_id="40070"></Item>
		<Item itemName="Options: Auto-crossfade media items when editing" typeMenu="item" action_id="40041"></Item>
		<Item itemName="View: Toggle show/hide item labels" typeMenu="item" action_id="40651"></Item>
		
	</Item>
	<!-- Items -->
	
	<!-- Mouse Modifier -->
	<Item itemName="Mouse Modifier" typeMenu="subMenu">
		
		<Item itemName="Arrange view middle drag" typeMenu="subMenu">
			<Item itemName="No action" typeMenu="item" action_id="39768"></Item>
			<Item itemName="Hand scroll and horizontal zoom" typeMenu="item" action_id="39777"></Item>
			<Item itemName="Hand scroll" typeMenu="item" action_id="39770"></Item>
			<Item itemName="Horizontal zoom" typeMenu="item" action_id="39779"></Item>
			<Item itemName="Jog audio (factory default)" typeMenu="item" action_id="39772"></Item>
			<Item itemName="Marquee zoom" typeMenu="item" action_id="39775"></Item>
			<Item itemName="Scroll browser-style" typeMenu="item" action_id="39771"></Item>
			<Item itemName="Scrub audio" typeMenu="item" action_id="39769"></Item>
		</Item>
		
		<Item itemName="Arrange view right drag" typeMenu="subMenu">
			<Item itemName="No action" typeMenu="item" action_id="39256"></Item>
			<Item itemName="Add to razor edit area" typeMenu="item" action_id="39282"></Item>
			<Item itemName="Hand scroll and horizontal zoom" typeMenu="item" action_id="39271"></Item>
			<Item itemName="Hand scroll" typeMenu="item" action_id="39264"></Item>
			<Item itemName="Horizontal zoom" typeMenu="item" action_id="39273"></Item>
			<Item itemName="Jog audio" typeMenu="item" action_id="39267"></Item>
			<Item itemName="Marquee zoom" typeMenu="item" action_id="39270"></Item>
			<Item itemName="Scroll browser-style" typeMenu="item" action_id="39265"></Item>
			<Item itemName="Scrub audio" typeMenu="item" action_id="39266"></Item>
		</Item>
		
		<Item itemName="Edit cursor handle left drag" typeMenu="subMenu">
			<Item itemName="No action" typeMenu="item" action_id="39800"></Item>
			<Item itemName="Scrub audio" typeMenu="item" action_id="39801"></Item>
			<Item itemName="Jog audio (factory default)" typeMenu="item" action_id="39802"></Item>
			<Item itemName="Jog audio (looped-segment mode)" typeMenu="item" action_id="39804"></Item>
		</Item>
		
		<Item itemName="MIDI CC lane left click/drag" typeMenu="subMenu">
			<Item itemName="No action" typeMenu="item" action_id="39352"></Item>
			<Item itemName="Edit CC events" typeMenu="item" action_id="39368"></Item>
			<Item itemName="Marquee select CC" typeMenu="item" action_id="39361"></Item>
			<Item itemName="Linear ramp CC events" typeMenu="item" action_id="39357"></Item>
			<Item itemName="Linear ramp CC events ignoring selection" typeMenu="item" action_id="39356"></Item>
		</Item>
		
		<Item itemName="MIDI CC event left click/drag" typeMenu="subMenu">
			<Item itemName="No action" typeMenu="item" action_id="39384"></Item>
			<Item itemName="Edit CC events" typeMenu="item" action_id="39408"></Item>
			<Item itemName="Marquee select CC" typeMenu="item" action_id="39395"></Item>
			<Item itemName="Linear ramp CC events" typeMenu="item" action_id="39409"></Item>
		</Item>
		
		<Item itemName="MIDI ruler left drag" typeMenu="subMenu">
			<Item itemName="No action" typeMenu="item" action_id="39416"></Item>
			<Item itemName="Edit loop point (ruler) or time selection (piano roll) (factory default)" typeMenu="item" action_id="39417"></Item>
			<Item itemName="Edit loop point (ruler) or time selection (piano roll) ignoring snap" typeMenu="item" action_id="39418"></Item>
		</Item>
		
		<Item itemName="MIDI piano roll left drag" typeMenu="subMenu">
			<Item itemName="No action" typeMenu="item" action_id="39480"></Item>
			<Item itemName="Marquee select notes" typeMenu="item" action_id="39487"></Item>
			<Item itemName="Scrub preview MIDI" typeMenu="item" action_id="39496"></Item>
		</Item>
		
		<Item itemName="Track left click" typeMenu="subMenu">
			<Item itemName="No action" typeMenu="item" action_id="39576"></Item>
			<Item itemName="Deselect all items" typeMenu="item" action_id="39579"></Item>
			<Item itemName="Deselect all items and move edit cursor (factory default)" typeMenu="item" action_id="39577"></Item>
			<Item itemName="Deselect all items and move edit cursor ignoring snap" typeMenu="item" action_id="39578"></Item>
		</Item>
		
		<Item itemName="Track left drag" typeMenu="subMenu">
			<Item itemName="No action" typeMenu="item" action_id="39192"></Item>
			<Item itemName="Add to razor edit area" typeMenu="item" action_id="39219"></Item>
			<Item itemName="Marquee zoom" typeMenu="item" action_id="39214"></Item>
			<Item itemName="Marquee select items" typeMenu="item" action_id="39201"></Item>
			<Item itemName="Marquee add to item selection" typeMenu="item" action_id="39205"></Item>
		</Item>
	</Item>
	<!-- Mouse Modifier -->
	
	<!-- Project -->
	<Item itemName="Project" typeMenu="subMenu">
		<Item itemName="Options: Preferences..." typeMenu="item" action_id="40016"></Item>
		<Item itemName="View: Show project bay window" typeMenu="item" action_id="41157"></Item>
		<Item itemName="" typeMenu="separator"></Item>
		<Item itemName="File: Project settings..." typeMenu="item" action_id="40021"></Item>
		<Item itemName="File: Clean current project directory..." typeMenu="item" action_id="40098"></Item>
		<Item itemName="File: Export project MIDI..." typeMenu="item" action_id="40849"></Item>
		<Item itemName="File: Render project to disk..." typeMenu="item" action_id="40015"></Item>
		<Item itemName="" typeMenu="separator"></Item>
		<Item itemName="Project settings: Timebase help..." typeMenu="item" action_id="41825"></Item>
	</Item>
	<!-- Project -->
	
	<!-- Tracks -->
	<Item itemName="Tracks" typeMenu="subMenu">
		<item itemName="Track: Set track grouping parameters" typeMenu="item" action_id="40772" />
		<Item itemName="" typeMenu="separator"></Item>
		<item itemName="Automation: Set track automation mode to trim/read" typeMenu="item" action_id="40400" />
		<item itemName="Automation: Set track automation mode to write" typeMenu="item" action_id="40403" />
		<item itemName="Automation: Set track automation mode to touch" typeMenu="item" action_id="40402" />
	</Item>
	<!-- Tracks -->
	
	<!-- Настройки -->
	<Item itemName="" typeMenu="separator"></Item>
	<Item itemName="Настройки" typeMenu="subMenu">
		<item itemName="Удалить файл кэша" typeMenu="item" action_id="delete_cache" />
		<item itemName="Окрыть XML" typeMenu="item" action_id="open_in_notepadpp" />
	</Item>
	<!-- Настройки -->
</root>
]]
    local file = io.open(xmlFilePath, "w")
    if file then
        file:write(defaultXML)
        file:close()
    else
        print_rs("Ошибка создания XML-файла.\n\n01. Перед запуском скрипта создайте папку в которой хотите хранить настройки меню\n\n02. Проверте пути в скрипте к этой папке\n\nСейчас в пути прописано это:\n" .. xmlFilePath)
    end
end
-- Функция для создания XML-файла по умолчанию
-- #####################################################
-- #####################################################
function print_rs (param)
	reaper.ShowConsoleMsg (tostring (param) .. "\n"); -- print_rs ("ReaScript console output")
end
-- #####################################################
-- #####################################################
function printTable(tbl, indent)
    indent = indent or 0  -- Устанавливаем отступ по умолчанию в 0, если он не задан
    local prefix = string.rep("  ", indent)  -- Создаем строку отступа на основе текущего уровня отступа

    for k, v in pairs(tbl) do  -- Проходим по всем парам ключ-значение в таблице
        if type(v) == "table" then  -- Если значение является таблицей
            reaper.ShowConsoleMsg(prefix .. tostring(k) .. ": {\n")  -- Печатаем ключ и открывающую скобку для новой таблицы
            printTable(v, indent + 1)  -- Рекурсивно вызываем printTable для вложенной таблицы, увеличивая уровень отступа
            reaper.ShowConsoleMsg(prefix .. "}\n")  -- Печатаем закрывающую скобку для таблицы
        else  -- Если значение не является таблицей
            reaper.ShowConsoleMsg(prefix .. tostring(k) .. ": " .. tostring(v) .. "\n")  -- Печатаем ключ и значение
        end
    end
end

function printValue(value, indent)
    indent = indent or 0  -- Устанавливаем отступ по умолчанию в 0, если он не задан
    local prefix = string.rep("  ", indent)  -- Создаем строку отступа на основе текущего уровня отступа

    if type(value) == "table" then  -- Если значение является таблицей
        reaper.ShowConsoleMsg(prefix .. "{\n")  -- Печатаем открывающую скобку для таблицы
        for k, v in pairs(value) do  -- Проходим по всем парам ключ-значение в таблице
            reaper.ShowConsoleMsg(prefix .. "  " .. tostring(k) .. ": ")  -- Печатаем ключ с отступом
            printValue(v, indent + 1)  -- Рекурсивно вызываем printValue для значения, увеличивая уровень отступа
        end
        reaper.ShowConsoleMsg(prefix .. "}\n")  -- Печатаем закрывающую скобку для таблицы
    else  -- Если значение не является таблицей
        reaper.ShowConsoleMsg(prefix .. tostring(value) .. "\n")  -- Печатаем значение
    end
end
-- #####################################################
-- #####################################################
-- Путь до XML-файла меню
local xmlFilePath = reaper.GetResourcePath():gsub('\\', '/') .. xmlFileName
local txtFilePath = reaper.GetResourcePath():gsub('\\', '/') .. txtFileName
-- #####################################################
-- #####################################################
-- Функция для добавления FX
function Add_FX(name, preset_name)
    local fxfloat = reaper.SNM_GetIntConfigVar('fxfloat_focus', 0)
    local change_setting = false
    if fxfloat & 4 == 4 then
        local fxfloat2 = fxfloat & ~(fxfloat & 4)
        reaper.SNM_SetIntConfigVar('fxfloat_focus', fxfloat2)
        change_setting = true
    end

    reaper.PreventUIRefresh(1)

    local cursor = reaper.GetCursorContext2(true)
    local master = reaper.GetMasterTrack(0)
    local add_to_master = false
    local insert_string = ""

    if add_fx_to_master_track then
        if (add_fx_to_item == false and add_fx_to_track == true and reaper.IsTrackSelected(master) == true)
            or (add_fx_to_item == true and add_fx_to_track == true and cursor == 0 and reaper.IsTrackSelected(master) == true)
        then
            local fx_index = reaper.TrackFX_AddByName(master, name, false, -1)
            if fx_index ~= -1 then
                add_to_master = true
                if preset_name then
                    reaper.TrackFX_SetPreset(master, fx_index, preset_name)
                end
                if show_fx and reaper.TrackFX_GetOffline(master, fx_index) == false
                    and reaper.CountSelectedTracks(0) == 0 then
                    reaper.TrackFX_Show(master, fx_index, 3)
                end
            end
            insert_string = "to master track"
        end
    end

    if (add_fx_to_item == false and add_fx_to_track == true)
        or (add_fx_to_item == true and add_fx_to_track == true and cursor == 0)
    then
        if reaper.CountSelectedTracks(0) > 0 then
            for i = 0, reaper.CountSelectedTracks(0) - 1 do
                local track = reaper.GetSelectedTrack(0, i)
                local fx_index = reaper.TrackFX_AddByName(track, name, false, -1)
                if fx_index ~= -1 then
                    if preset_name then
                        reaper.TrackFX_SetPreset(track, fx_index, preset_name)
                    end
                    if show_fx and reaper.CountSelectedTracks(0) == 1
                        and reaper.TrackFX_GetOffline(track, fx_index) == false
                        and add_to_master == false
                    then
                        reaper.TrackFX_Show(track, fx_index, 3)
                    end
                end
            end
            insert_string = "to selected tracks"
        end
    elseif (add_fx_to_track == false and add_fx_to_item == true)
        or (add_fx_to_track == true and add_fx_to_item == true and cursor == 1)
    then
        if reaper.CountSelectedMediaItems(0) > 0 then
            for i = 0, reaper.CountSelectedMediaItems(0) - 1 do
                local item = reaper.GetSelectedMediaItem(0, i)
                local take = reaper.GetActiveTake(item)
                local fx_index = reaper.TakeFX_AddByName(take, name, -1)
                if fx_index ~= -1 then
                    if preset_name then
                        reaper.TakeFX_SetPreset(take, fx_index, preset_name)
                    end
                    if show_fx and reaper.CountSelectedMediaItems(0) == 1
                        and reaper.TakeFX_GetOffline(take, fx_index) == false then
                        reaper.TakeFX_Show(take, fx_index, 3)
                    end
                end
            end
            insert_string = "to selected items"
        end
    end

    if change_setting == true then
        reaper.SNM_SetIntConfigVar('fxfloat_focus', fxfloat)
    end

    reaper.PreventUIRefresh(-1)
end
-- Функция для добавления FX
-- #####################################################
-- #####################################################
-- Функция для создания строки меню из таблицы и сохранения действий
function createMenuString(tbl, actions)  -- Определение функции createMenuString с параметрами tbl (таблица меню) и actions (таблица действий)
    local menuString = ""  -- Инициализация пустой строки menuString, которая будет содержать строку меню
	
	if tbl then  -- Проверка, существует ли таблица tbl
		for index, item in ipairs(tbl.children) do  -- Итерация по всем элементам children в таблице tbl
			if item.typeMenu == "subMenu" then  -- Проверка, является ли текущий элемент подменю
				menuString = menuString .. ">" .. item.itemName .. "|"  -- Добавление обозначения начала подменю и имени элемента в строку menuString
				menuString = menuString .. createMenuString(item, actions)  -- Рекурсивный вызов createMenuString для обработки подменю и добавление результата в menuString
				menuString = menuString .. "<|"  -- Добавление обозначения конца подменю в строку menuString
			elseif item.typeMenu == "item" then  -- Проверка, является ли текущий элемент пунктом меню
				if item.action_id then  -- Проверка, существует ли у элемента идентификатор действия (action_id)
					if item.action_id == "disabled_item" then
						item.itemName = "#" .. item.itemName  -- Добавление '#' перед именем элемента для указания, что он отключен
					else
						local commandId = reaper.NamedCommandLookup(item.action_id)  -- Поиск идентификатора команды по action_id
						if commandId > 0 then  -- Проверка, найден ли идентификатор команды
							local commandState = reaper.GetToggleCommandStateEx(0, commandId)  -- Получение состояния команды (включена/выключена) в главном разделе (section 0)
							if commandState == 1 then  -- Проверка, включена ли команда
								item.itemName = "!" .. item.itemName  -- Добавление '!' перед именем элемента для указания, что команда включена
							end
						end
					end
				end
				menuString = menuString .. item.itemName .. "|"  -- Добавление имени элемента в строку menuString
				table.insert(actions, {action_id = item.action_id, add_fx = item.add_fx, preset_name = item.preset_name})  -- Добавление действия в таблицу actions
			elseif item.typeMenu == "separator" then  -- Проверка, является ли текущий элемент разделителем
				menuString = menuString .. "|"  -- Добавление разделителя в строку menuString
			end
		end
    end
	
    return menuString  -- Возврат сформированной строки меню
end
-- Функция для создания строки меню из таблицы и сохранения действий
-- #####################################################
-- #####################################################
-- Функция для парсинга атрибутов из строки
function parseAttributes(attrs)
    local attributes = {}
    for key, value in string.gmatch(attrs, '([%w_]+)="([^"]*)"') do
        attributes[key] = value
    end
    return attributes
end
-- Функция для парсинга атрибутов из строки
-- #####################################################
-- #####################################################
-- Функция для парсинга XML
function parseXML(xml)
    local stack = {}
    local top = {itemName = nil, typeMenu = "root", children = {}}
    table.insert(stack, top)

    local i = 1
    while true do
        local ni, j, close, label, attrs, empty = string.find(xml, "<(%/?)%s*([%w_:]+)(.-)(%/?)>", i)

        -- Проверка на комментарии
        local comment_start, comment_end = string.find(xml, "<!%-%-", i)
        if comment_start and (not ni or comment_start < ni) then
            local comment_close = string.find(xml, "%-%->", comment_start)
            if comment_close then
                i = comment_close + 3
                goto continue
            end
        end

        if not ni then break end

        local text = string.sub(xml, i, ni - 1)
        if not string.find(text, "^%s*$") then
            table.insert(stack[#stack].children, text)
        end

        if empty == "/" then
            table.insert(stack[#stack].children, {itemName = label, attrs = parseAttributes(attrs), children = {}})
        elseif close == "" then
            local newNode = {itemName = label, attrs = parseAttributes(attrs), children = {}}
            table.insert(stack[#stack].children, newNode)
            table.insert(stack, newNode)
        else
            if stack[#stack].itemName ~= label then
                error("XML Error: Mismatched tags")
            end
            table.remove(stack)
        end
        i = j + 1

        ::continue::
    end

    return top.children[1]
end
-- Функция для парсинга XML
-- #####################################################
-- #####################################################
-- Функция для создания таблицы из узла XML
function buildLuaTable(node)  -- Определение функции buildLuaTable с параметром node (узел XML)
    local result = {  -- Создание таблицы result для хранения данных узла
        itemName = node.attrs.itemName,  -- Копирование атрибута itemName из узла в таблицу result
        typeMenu = node.attrs.typeMenu,  -- Копирование атрибута typeMenu из узла в таблицу result
        action_id = node.attrs.action_id,  -- Копирование атрибута action_id из узла в таблицу result
        add_fx = node.attrs.add_fx,  -- Копирование атрибута add_fx из узла в таблицу result
        preset_name = node.attrs.preset_name,  -- Копирование атрибута preset_name из узла в таблицу result
        children = {}  -- Инициализация пустого списка для дочерних элементов
    }
    for _, child in ipairs(node.children) do  -- Итерация по всем дочерним элементам узла
        if type(child) == "table" then  -- Проверка, является ли дочерний элемент таблицей
            table.insert(result.children, buildLuaTable(child))  -- Рекурсивный вызов buildLuaTable для дочернего элемента и добавление результата в список children
        end
    end
    return result  -- Возврат таблицы result как результата функции
end  -- Завершение функции buildLuaTable
-- Функция для создания таблицы из узла XML
-- #####################################################
-- #####################################################
-- Функция для сериализации таблицы Lua в строку
function serializeTable(tbl, indent)
    indent = indent or 0
    local str = "{\n"
    local indentation = string.rep("   ", indent) -- Увеличиваем отступы с каждым уровнем
    for k, v in pairs(tbl) do
        local key = type(k) == "number" and "[" .. k .. "]" or '["' .. k .. '"]'
        if type(v) == "table" then
            str = str .. indentation .. key .. " = " .. serializeTable(v, indent + 1) .. ",\n"
        elseif type(v) == "string" then
            str = str .. indentation .. key .. ' = "' .. v .. '",\n'
        elseif type(v) == "boolean" then
            str = str .. indentation .. key .. ' = ' .. (v and "true" or "false") .. ",\n"
        else
            str = str .. indentation .. key .. " = " .. tostring(v) .. ",\n"
        end
    end
    str = str .. string.rep("    ", indent - 1) .. "}\n"
    return str
end
-- Функция для сериализации таблицы Lua в строку
-- #####################################################
-- #####################################################
-- Функция для сохранения таблицы Lua в файл
function saveTableToFile(tbl, filename)
    local file = io.open(filename, "w")
    if file then
        file:write("return ")
        file:write(serializeTable(tbl))
        file:close()
        return true
    else
        return false
    end
end
-- Функция для сохранения таблицы Lua в файл
-- #####################################################
-- #####################################################
-- Функция для загрузки таблицы Lua из файла
function loadTableFromFile(filename)
    local chunk = loadfile(filename)
    if chunk then
        return chunk()
    else
        return nil
    end
end
-- Функция для загрузки таблицы Lua из файла
-- #####################################################
-- #####################################################
function openFileInNotepadPP(filePath)
    local command = '"' .. notepadPPPath .. '" "' .. filePath .. '"'
    -- os.execute(command)
    reaper.ExecProcess(command, -2)
end
-- #####################################################
-- #####################################################
function showMenu()  -- Определение функции showMenu
	-- Проверка существования Lua-файла
	local luaTable  -- Объявление переменной luaTable для хранения загруженной таблицы
	if reaper.file_exists(txtFilePath) then -- Проверка существования TXT файла
		luaTable = loadTableFromFile(txtFilePath)  -- Загрузка таблицы из TXT файла
		
	elseif reaper.file_exists(xmlFilePath) then -- Проверка существования XML файла
		local title = reaper.JS_Localize('ReaScript console output', "common")  -- Локализация заголовка окна консоли ReaScript
		local hwnd = reaper.JS_Window_Find(title, true)  -- Поиск окна с заданным заголовком
		if hwnd then reaper.JS_Window_Destroy(hwnd) end  -- Уничтожение окна, если оно найдено
		
		local file = io.open(xmlFilePath, "r")  -- Открытие XML файла для чтения
		local xml = file:read("*all")  -- Чтение всего содержимого XML файла
		file:close()  -- Закрытие файла
		local parsedXML = parseXML(xml)  -- Парсинг XML содержимого в структуру данных
		luaTable = buildLuaTable(parsedXML)  -- Построение таблицы Lua из структуры данных XML
		
		saveTableToFile(luaTable, txtFilePath)  -- Сохранение таблицы Lua в TXT файл для кэширования
		-- print_rs ( "XML файл" )  -- Закомментированная строка для отладки, которая выводит сообщение о загрузке из XML файла
	else  -- Если ни TXT, ни XML файл не найден
		local title = reaper.JS_Localize('ReaScript console output', "common")  -- Локализация заголовка окна консоли ReaScript
		local hwnd = reaper.JS_Window_Find(title, true)  -- Поиск окна с заданным заголовком
		if hwnd then reaper.JS_Window_Destroy(hwnd) end  -- Уничтожение окна, если оно найдено
		
		-- Предложить пользователю указать путь к XML файлу или создать новый
		local ret = reaper.ShowMessageBox("Не найдено ни одной таблицы меню.\n\nВ настройках скрипта укажите правильный путь к XML-файлу или создайте новый XML-файл по умолчанию.\n\nСоздать новый XML-файл по умолчанию ?", "Ошибка", 1)  -- Показать сообщение пользователю с предложением создать новый XML файл

		if ret == 1 then -- Если пользователь выбрал "Да"
			createDefaultXML(xmlFilePath)  -- Создание нового XML файла по умолчанию
			local ret = reaper.ShowMessageBox("XML-файл по умолчанию успешно создан, вызовите ещё раз скрипт и вы увидите меню по умолчанию", "Ошибка", 0)  -- Показать сообщение об успешном создании XML файла
		else -- Пользователь выбрал "Отмена", окно просто закрывается
			-- print_rs ("Не найдено ни одной таблицы меню. \n\nУкажите правильный путь к файлу XML в начале этого скрипта \n\nСейчас путь в скрипте до XML-файла указан такой:\n\n" .. reaper.GetResourcePath():gsub('\\', '/') .. xmlFileName)  -- Закомментированная строка для отладки, которая выводит сообщение о необходимости указать путь к XML файлу
			return  -- Завершение функции
		end
	end
	-- Проверка существования Lua-файла

	-- Сохранение действий и создание строки меню
	local actions = {}  -- Инициализация пустой таблицы действий
	local menuString = createMenuString(luaTable, actions)  -- Создание строки меню и заполнение таблицы действий
	
	-- Инициализация графического окна и показ меню header_name
	local x_mouse, y_mouse = reaper.GetMousePosition()  -- Получение текущей позиции курсора мыши

	gfx.init(header_name, menu_header_width_x, menu_header_width_y, 0, x_mouse + menu_header_position_x, y_mouse + menu_header_position_y)  -- Инициализация графического окна меню
	
	-- Скрыть/показать заголовок окна меню
	if show_window_header == false then  -- Если флаг show_window_header установлен в false
		gfx.x, gfx.y = gfx.mouse_x + menu_header_position_x, gfx.mouse_y + menu_header_position_y  -- Установка позиции окна меню относительно курсора мыши
	end

	local selection = gfx.showmenu(menuString)  -- Показ меню и получение выбранного элемента
	
	-- Обработка выбора пункта меню
	if selection > 0 then  -- Если был выбран пункт меню
		local selectedAction = actions[selection]  -- Получение соответствующего действия из таблицы actions
		
		if selectedAction then  -- Если действие существует
			if selectedAction.action_id then  -- Если у действия есть идентификатор команды
				if selectedAction.action_id == "delete_cache" then  -- Если действие - удаление кэша
					gfx.quit()  -- Принудительное закрытие меню
					os.remove(txtFilePath)  -- Удаление TXT файла кэша
				elseif selectedAction.action_id == "open_in_notepadpp" then  -- Если действие - открытие в Notepad++
					gfx.quit()  -- Принудительное закрытие меню
					openFileInNotepadPP(xmlFilePath)  -- Открытие XML файла в Notepad++
				else  -- Если действие - выполнение команды Reaper
					gfx.quit()  -- Принудительное закрытие меню
					reaper.Main_OnCommand(reaper.NamedCommandLookup(selectedAction.action_id), 0)  -- Выполнение команды Reaper
				end
			elseif selectedAction.add_fx then  -- Если действие - добавление FX
				gfx.quit()  -- Принудительное закрытие меню
				Add_FX(selectedAction.add_fx, selectedAction.preset_name)  -- Добавление FX с заданным именем и пресетом
			end
		end
		gfx.quit()  -- Принудительное закрытие меню
	end
	-- Обработка выбора пункта меню
end  -- Завершение функции showMenu
-- #####################################################
-- #####################################################
reaper.defer(showMenu)
-- #####################################################
-- #####################################################
reaper.PreventUIRefresh(-1)
reaper.TrackList_AdjustWindows(0)  -- Updates the window view
reaper.UpdateArrange()  -- Updates the window view
-- #######################################
-- #######################################
--[[
APIExists
APITest
AddMediaItemToTrack
AddProjectMarker
AddProjectMarker2
AddRemoveReaScript
AddTakeToMediaItem
AddTempoTimeSigMarker
AnyTrackSolo
ApplyNudge
ArmCommand
AudioAccessorStateChanged
AudioAccessorUpdate
AudioAccessorValidateState
Audio_Init
Audio_IsPreBuffer
Audio_IsRunning
Audio_Quit
BR_EnvAlloc
BR_EnvCountPoints
BR_EnvDeletePoint
BR_EnvFind
BR_EnvFindNext
BR_EnvFindPrevious
BR_EnvFree
BR_EnvGetParentTake
BR_EnvGetParentTrack
BR_EnvGetPoint
BR_EnvGetProperties
BR_EnvSetPoint
BR_EnvSetProperties
BR_EnvValueAtPos
BR_GetMediaSourceProperties
BR_GetMouseCursorContext
BR_GetMouseCursorContext_Envelope
BR_GetMouseCursorContext_Item
BR_GetMouseCursorContext_MIDI
BR_GetMouseCursorContext_Position
BR_GetMouseCursorContext_StretchMarker
BR_GetMouseCursorContext_Take
BR_GetMouseCursorContext_Track
BR_ItemAtMouseCursor
BR_MIDI_CCLaneRemove
BR_MIDI_CCLaneReplace
BR_PositionAtMouseCursor
BR_SetMediaSourceProperties
BR_SetTakeSourceFromFile
BR_SetTakeSourceFromFile2
BR_TakeAtMouseCursor
BR_TrackAtMouseCursor
BypassFxAllTracks
CSurf_FlushUndo
CSurf_GetTouchState
CSurf_GoEnd
CSurf_GoStart
CSurf_NumTracks
CSurf_OnArrow
CSurf_OnFXChange
CSurf_OnFwd
CSurf_OnInputMonitorChange
CSurf_OnInputMonitorChangeEx
CSurf_OnMuteChange
CSurf_OnMuteChangeEx
CSurf_OnPanChange
CSurf_OnPanChangeEx
CSurf_OnPause
CSurf_OnPlay
CSurf_OnPlayRateChange
CSurf_OnRecArmChange
CSurf_OnRecArmChangeEx
CSurf_OnRecord
CSurf_OnRecvPanChange
CSurf_OnRecvVolumeChange
CSurf_OnRew
CSurf_OnRewFwd
CSurf_OnScroll
CSurf_OnSelectedChange
CSurf_OnSendPanChange
CSurf_OnSendVolumeChange
CSurf_OnSoloChange
CSurf_OnSoloChangeEx
CSurf_OnStop
CSurf_OnTempoChange
CSurf_OnTrackSelection
CSurf_OnVolumeChange
CSurf_OnVolumeChangeEx
CSurf_OnWidthChange
CSurf_OnWidthChangeEx
CSurf_OnZoom
CSurf_ResetAllCachedVolPanStates
CSurf_ScrubAmt
CSurf_SetAutoMode
CSurf_SetPlayState
CSurf_SetRepeatState
CSurf_SetSurfaceMute
CSurf_SetSurfacePan
CSurf_SetSurfaceRecArm
CSurf_SetSurfaceSelected
CSurf_SetSurfaceSolo
CSurf_SetSurfaceVolume
CSurf_SetTrackListChange
CSurf_TrackFromID
CSurf_TrackToID
CalculateNormalization
ClearAllRecArmed
ClearConsole
ClearPeakCache
ColorFromNative
ColorToNative
CountAutomationItems
CountEnvelopePoints
CountEnvelopePointsEx
CountMediaItems
CountProjectMarkers
CountSelectedMediaItems
CountSelectedTracks
CountSelectedTracks2
CountTCPFXParms
CountTakeEnvelopes
CountTakes
CountTempoTimeSigMarkers
CountTrackEnvelopes
CountTrackMediaItems
CountTracks
CreateNewMIDIItemInProj
CreateTakeAudioAccessor
CreateTrackAudioAccessor
CreateTrackSend
DB2SLIDER
DeleteEnvelopePointEx
DeleteEnvelopePointRange
DeleteEnvelopePointRangeEx
DeleteExtState
DeleteProjectMarker
DeleteProjectMarkerByIndex
DeleteTakeMarker
DeleteTakeStretchMarkers
DeleteTempoTimeSigMarker
DeleteTrack
DeleteTrackMediaItem
DestroyAudioAccessor
DockGetPosition
DockIsChildOfDock
DockWindowActivate
DockWindowAdd
DockWindowAddEx
DockWindowRefresh
DockWindowRefreshForHWND
DockWindowRemove
Dock_UpdateDockID
EditTempoTimeSigMarker
EnsureNotCompletelyOffscreen
EnumPitchShiftModes
EnumPitchShiftSubModes
EnumProjExtState
EnumProjectMarkers
EnumProjectMarkers2
EnumProjectMarkers3
EnumProjects
EnumRegionRenderMatrix
EnumTrackMIDIProgramNames
EnumTrackMIDIProgramNamesEx
EnumerateFiles
EnumerateSubdirectories
Envelope_Evaluate
Envelope_FormatValue
Envelope_GetParentTake
Envelope_GetParentTrack
Envelope_SortPoints
Envelope_SortPointsEx
ExecProcess
FNG_AddMidiNote
FNG_AllocMidiTake
FNG_CountMidiNotes
FNG_FreeMidiTake
FNG_GetMidiNote
FNG_GetMidiNoteIntProperty
FNG_SetMidiNoteIntProperty
FindTempoTimeSigMarker
GR_SelectColor
GSC_mainwnd
GetActiveTake
GetAllProjectPlayStates
GetAppVersion
GetArmedCommand
GetAudioAccessorEndTime
GetAudioAccessorHash
GetAudioAccessorSamples
GetAudioAccessorStartTime
GetAudioDeviceInfo
GetConfigWantsDock
GetCurrentProjectInLoadSave
GetCursorContext
GetCursorContext2
GetCursorPosition
GetCursorPositionEx
GetDisplayedMediaItemColor
GetDisplayedMediaItemColor2
GetEnvelopeInfo_Value
GetEnvelopeName
GetEnvelopePoint
GetEnvelopePointByTime
GetEnvelopePointByTimeEx
GetEnvelopePointEx
GetEnvelopeScalingMode
GetEnvelopeStateChunk
GetExePath
GetExtState
GetFXEnvelope
GetFocusedFX
GetFocusedFX2
GetFreeDiskSpaceForRecordPath
GetGlobalAutomationOverride
GetHZoomLevel
GetInputChannelName
GetInputOutputLatency
GetItemEditingTime2
GetItemFromPoint
GetItemProjectContext
GetItemStateChunk
GetLastColorThemeFile
GetLastMarkerAndCurRegion
GetLastTouchedFX
GetLastTouchedTrack
GetMIDIInputName
GetMIDIOutputName
GetMainHwnd
GetMasterMuteSoloFlags
GetMasterTrack
GetMasterTrackVisibility
GetMaxMidiInputs
GetMaxMidiOutputs
GetMediaFileMetadata
GetMediaItem
GetMediaItemInfo_Value
GetMediaItemNumTakes
GetMediaItemTake
GetMediaItemTakeByGUID
GetMediaItemTakeInfo_Value
GetMediaItemTake_Item
GetMediaItemTake_Peaks
GetMediaItemTake_Source
GetMediaItemTake_Track
GetMediaItemTrack
GetMediaItem_Track
GetMediaSourceFileName
GetMediaSourceLength
GetMediaSourceNumChannels
GetMediaSourceParent
GetMediaSourceSampleRate
GetMediaSourceType
GetMediaTrackInfo_Value
GetMixerScroll
GetMouseModifier
GetMousePosition
GetNumAudioInputs
GetNumAudioOutputs
GetNumMIDIInputs
GetNumMIDIOutputs
GetNumTakeMarkers
GetNumTracks
GetOS
GetOutputChannelName
GetOutputLatency
GetParentTrack
GetPeakFileName
GetPeakFileNameEx
GetPeakFileNameEx2
GetPlayPosition
GetPlayPosition2
GetPlayPosition2Ex
GetPlayPositionEx
GetPlayState
GetPlayStateEx
GetProjExtState
GetProjectLength
GetProjectName
GetProjectPath
GetProjectPathEx
GetProjectStateChangeCount
GetProjectTimeOffset
GetProjectTimeSignature
GetProjectTimeSignature2
GetResourcePath
GetSelectedEnvelope
GetSelectedMediaItem
GetSelectedTrack
GetSelectedTrack2
GetSelectedTrackEnvelope
GetSetAutomationItemInfo
GetSetAutomationItemInfo_String
GetSetEnvelopeInfo_String
GetSetEnvelopeState
GetSetEnvelopeState2
GetSetItemState
GetSetItemState2
GetSetMediaItemInfo_String
GetSetMediaItemTakeInfo_String
GetSetMediaTrackInfo_String
GetSetProjectAuthor
GetSetProjectGrid
GetSetProjectInfo
GetSetProjectInfo_String
GetSetProjectNotes
GetSetRepeat
GetSetRepeatEx
GetSetTrackGroupMembership
GetSetTrackGroupMembershipHigh
GetSetTrackSendInfo_String
GetSetTrackState
GetSetTrackState2
GetSet_ArrangeView2
GetSet_LoopTimeRange
GetSet_LoopTimeRange2
GetSubProjectFromSource
GetTCPFXParm
GetTake
GetTakeEnvelope
GetTakeEnvelopeByName
GetTakeMarker
GetTakeName
GetTakeNumStretchMarkers
GetTakeStretchMarker
GetTakeStretchMarkerSlope
GetTempoMatchPlayRate
GetTempoTimeSigMarker
GetThemeColor
GetThingFromPoint
GetToggleCommandState
GetToggleCommandState3
GetToggleCommandStateEx
GetTooltipWindow
GetTrack
GetTrackAutomationMode
GetTrackColor
GetTrackDepth
GetTrackEnvelope
GetTrackEnvelopeByChunkName
GetTrackEnvelopeByName
GetTrackFromPoint
GetTrackGUID
GetTrackMIDILyrics
GetTrackMIDINoteName
GetTrackMIDINoteNameEx
GetTrackMIDINoteRange
GetTrackMediaItem
GetTrackName
GetTrackNumMediaItems
GetTrackNumSends
GetTrackReceiveName
GetTrackReceiveUIMute
GetTrackReceiveUIVolPan
GetTrackSendInfo_Value
GetTrackSendName
GetTrackSendUIMute
GetTrackSendUIVolPan
GetTrackState
GetTrackStateChunk
GetTrackUIMute
GetTrackUIPan
GetTrackUIVolPan
GetUnderrunTime
GetUserFileNameForRead
GetUserInputs
GetVolumeEnvelopeScaling
GoToMarker
GoToRegion
HasExtState
HasTrackMIDIPrograms
HasTrackMIDIProgramsEx
Help_Set
HiresPeaksFromSource
InsertAutomationItem
InsertEnvelopePoint
InsertEnvelopePointEx
InsertMedia
InsertMediaSection
InsertTrackAtIndex
IsMediaExtension
IsMediaItemSelected
IsProjectDirty
IsTrackSelected
IsTrackVisible
LICE_ClipLine
LocalizeString
Loop_OnArrow
MB
MIDIEditor_EnumTakes
MIDIEditor_GetActive
MIDIEditor_GetMode
MIDIEditor_GetSetting_int
MIDIEditor_GetSetting_str
MIDIEditor_GetTake
MIDIEditor_LastFocused_OnCommand
MIDIEditor_OnCommand
MIDIEditor_SetSetting_int
MIDI_CountEvts
MIDI_DeleteCC
MIDI_DeleteEvt
MIDI_DeleteNote
MIDI_DeleteTextSysexEvt
MIDI_DisableSort
MIDI_EnumSelCC
MIDI_EnumSelEvts
MIDI_EnumSelNotes
MIDI_EnumSelTextSysexEvts
MIDI_GetAllEvts
MIDI_GetCC
MIDI_GetCCShape
MIDI_GetEvt
MIDI_GetGrid
MIDI_GetHash
MIDI_GetNote
MIDI_GetPPQPosFromProjQN
MIDI_GetPPQPosFromProjTime
MIDI_GetPPQPos_EndOfMeasure
MIDI_GetPPQPos_StartOfMeasure
MIDI_GetProjQNFromPPQPos
MIDI_GetProjTimeFromPPQPos
MIDI_GetRecentInputEvent
MIDI_GetScale
MIDI_GetTextSysexEvt
MIDI_GetTrackHash
MIDI_InsertCC
MIDI_InsertEvt
MIDI_InsertNote
MIDI_InsertTextSysexEvt
MIDI_SelectAll
MIDI_SetAllEvts
MIDI_SetCC
MIDI_SetCCShape
MIDI_SetEvt
MIDI_SetItemExtents
MIDI_SetNote
MIDI_SetTextSysexEvt
MIDI_Sort
Main_OnCommand
Main_OnCommandEx
Main_SaveProject
Main_UpdateLoopInfo
Main_openProject
MarkProjectDirty
MarkTrackItemsDirty
Master_GetPlayRate
Master_GetPlayRateAtTime
Master_GetTempo
Master_NormalizePlayRate
Master_NormalizeTempo
MediaItemDescendsFromTrack
MoveEditCursor
MoveMediaItemToTrack
MuteAllTracks
NamedCommandLookup
OnPauseButton
OnPauseButtonEx
OnPlayButton
OnPlayButtonEx
OnStopButton
OnStopButtonEx
OpenColorThemeFile
OpenMediaExplorer
OscLocalMessageToHost
PCM_Sink_Enum
PCM_Sink_GetExtension
PCM_Sink_ShowConfig
PCM_Source_BuildPeaks
PCM_Source_CreateFromFile
PCM_Source_CreateFromFileEx
PCM_Source_CreateFromType
PCM_Source_Destroy
PCM_Source_GetPeaks
PCM_Source_GetSectionInfo
PluginWantsAlwaysRunFx
PreventUIRefresh
PromptForAction
ReaScriptError
RecursiveCreateDirectory
RefreshToolbar
RefreshToolbar2
RemoveTrackSend
RenderFileSection
ReorderSelectedTracks
Resample_EnumModes
ReverseNamedCommandLookup
SLIDER2DB
SNM_AddReceive
SNM_AddTCPFXParm
SNM_CreateFastString
SNM_DeleteFastString
SNM_GetDoubleConfigVar
SNM_GetFastString
SNM_GetFastStringLength
SNM_GetIntConfigVar
SNM_GetMIDIEditorActiveTake
SNM_GetMediaItemTakeByGUID
SNM_GetProjectMarkerName
SNM_GetSetObjectState
SNM_GetSetSourceState
SNM_GetSetSourceState2
SNM_GetSourceType
SNM_MoveOrRemoveTrackFX
SNM_RemoveReceive
SNM_RemoveReceivesFrom
SNM_SelectResourceBookmark
SNM_SetDoubleConfigVar
SNM_SetFastString
SNM_SetIntConfigVar
SNM_SetProjectMarker
SNM_TieResourceSlotActions
ScaleFromEnvelopeMode
ScaleToEnvelopeMode
SelectAllMediaItems
SelectProjectInstance
SetActiveTake
SetAutomationMode
SetCurrentBPM
SetCursorContext
SetEditCurPos
SetEditCurPos2
SetEnvelopePoint
SetEnvelopePointEx
SetEnvelopeStateChunk
SetExtState
SetGlobalAutomationOverride
SetItemStateChunk
SetMIDIEditorGrid
SetMasterTrackVisibility
SetMediaItemInfo_Value
SetMediaItemLength
SetMediaItemPosition
SetMediaItemSelected
SetMediaItemTakeInfo_Value
SetMediaItemTake_Source
SetMediaTrackInfo_Value
SetMixerScroll
SetMouseModifier
SetOnlyTrackSelected
SetProjExtState
SetProjectGrid
SetProjectMarker
SetProjectMarker2
SetProjectMarker3
SetProjectMarker4
SetProjectMarkerByIndex
SetProjectMarkerByIndex2
SetRegionRenderMatrix
SetTakeMarker
SetTakeStretchMarker
SetTakeStretchMarkerSlope
SetTempoTimeSigMarker
SetThemeColor
SetToggleCommandState
SetTrackAutomationMode
SetTrackColor
SetTrackMIDILyrics
SetTrackMIDINoteName
SetTrackMIDINoteNameEx
SetTrackSelected
SetTrackSendInfo_Value
SetTrackSendUIPan
SetTrackSendUIVol
SetTrackStateChunk
ShowActionList
ShowConsoleMsg
ShowMessageBox
ShowPopupMenu
SnapToGrid
SoloAllTracks
Splash_GetWnd
SplitMediaItem
StuffMIDIMessage
TakeFX_AddByName
TakeFX_CopyToTake
TakeFX_CopyToTrack
TakeFX_Delete
TakeFX_EndParamEdit
TakeFX_FormatParamValue
TakeFX_FormatParamValueNormalized
TakeFX_GetChainVisible
TakeFX_GetCount
TakeFX_GetEnabled
TakeFX_GetEnvelope
TakeFX_GetFXGUID
TakeFX_GetFXName
TakeFX_GetFloatingWindow
TakeFX_GetFormattedParamValue
TakeFX_GetIOSize
TakeFX_GetNamedConfigParm
TakeFX_GetNumParams
TakeFX_GetOffline
TakeFX_GetOpen
TakeFX_GetParam
TakeFX_GetParamEx
TakeFX_GetParamFromIdent
TakeFX_GetParamIdent
TakeFX_GetParamName
TakeFX_GetParamNormalized
TakeFX_GetParameterStepSizes
TakeFX_GetPinMappings
TakeFX_GetPreset
TakeFX_GetPresetIndex
TakeFX_GetUserPresetFilename
TakeFX_NavigatePresets
TakeFX_SetEnabled
TakeFX_SetNamedConfigParm
TakeFX_SetOffline
TakeFX_SetOpen
TakeFX_SetParam
TakeFX_SetParamNormalized
TakeFX_SetPinMappings
TakeFX_SetPreset
TakeFX_SetPresetByIndex
TakeFX_Show
TakeIsMIDI
ThemeLayout_GetLayout
ThemeLayout_GetParameter
ThemeLayout_RefreshAll
ThemeLayout_SetLayout
ThemeLayout_SetParameter
TimeMap2_GetDividedBpmAtTime
TimeMap2_GetNextChangeTime
TimeMap2_QNToTime
TimeMap2_beatsToTime
TimeMap2_timeToBeats
TimeMap2_timeToQN
TimeMap_GetDividedBpmAtTime
TimeMap_GetMeasureInfo
TimeMap_GetMetronomePattern
TimeMap_GetTimeSigAtTime
TimeMap_QNToMeasures
TimeMap_QNToTime
TimeMap_QNToTime_abs
TimeMap_curFrameRate
TimeMap_timeToQN
TimeMap_timeToQN_abs
ToggleTrackSendUIMute
TrackCtl_SetToolTip
TrackFX_AddByName
TrackFX_CopyToTake
TrackFX_CopyToTrack
TrackFX_Delete
TrackFX_EndParamEdit
TrackFX_FormatParamValue
TrackFX_FormatParamValueNormalized
TrackFX_GetByName
TrackFX_GetChainVisible
TrackFX_GetCount
TrackFX_GetEQ
TrackFX_GetEQBandEnabled
TrackFX_GetEQParam
TrackFX_GetEnabled
TrackFX_GetFXGUID
TrackFX_GetFXName
TrackFX_GetFloatingWindow
TrackFX_GetFormattedParamValue
TrackFX_GetIOSize
TrackFX_GetInstrument
TrackFX_GetNamedConfigParm
TrackFX_GetNumParams
TrackFX_GetOffline
TrackFX_GetOpen
TrackFX_GetParam
TrackFX_GetParamEx
TrackFX_GetParamFromIdent
TrackFX_GetParamIdent
TrackFX_GetParamName
TrackFX_GetParamNormalized
TrackFX_GetParameterStepSizes
TrackFX_GetPinMappings
TrackFX_GetPreset
TrackFX_GetPresetIndex
TrackFX_GetRecChainVisible
TrackFX_GetRecCount
TrackFX_GetUserPresetFilename
TrackFX_NavigatePresets
TrackFX_SetEQBandEnabled
TrackFX_SetEQParam
TrackFX_SetEnabled
TrackFX_SetNamedConfigParm
TrackFX_SetOffline
TrackFX_SetOpen
TrackFX_SetParam
TrackFX_SetParamNormalized
TrackFX_SetPinMappings
TrackFX_SetPreset
TrackFX_SetPresetByIndex
TrackFX_Show
TrackList_AdjustWindows
TrackList_UpdateAllExternalSurfaces
Track_GetPeakHoldDB
Track_GetPeakInfo
ULT_GetMediaItemNote
ULT_SetMediaItemNote
Undo_BeginBlock
Undo_BeginBlock2
Undo_CanRedo2
Undo_CanUndo2
Undo_DoRedo2
Undo_DoUndo2
Undo_EndBlock
Undo_EndBlock2
Undo_OnStateChange
Undo_OnStateChange2
Undo_OnStateChangeEx
Undo_OnStateChangeEx2
Undo_OnStateChange_Item
UpdateArrange
UpdateItemInProject
UpdateTimeline
ValidatePtr
ValidatePtr2
ViewPrefs
adjustZoom
file_exists
format_timestr
format_timestr_len
format_timestr_pos
genGuid
get_config_var_string
get_ini_file
guidToString
image_resolve_fn
joystick_create
joystick_destroy
joystick_enum
joystick_getaxis
joystick_getbuttonmask
joystick_getinfo
joystick_getpov
joystick_update
midi_init
midi_reinit
mkpanstr
mkvolpanstr
mkvolstr
my_getViewport
parse_timestr
parse_timestr_len
parse_timestr_pos
parsepanstr
plugin_getFilterList
plugin_getImportableProjectFilterList
reduce_open_files
relative_fn
resolve_fn
resolve_fn2
stringToGuid
time_precise
]]--